﻿Imports System.Data
Imports System.Linq
Imports System.Data.SqlClient
Public Class Form1
    Private Const ConnectionString As String = "Data Source=.\SQL2008R2;Initial Catalog=AjaxSamples;Integrated Security = true"
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        'Set Columns Count
        dataGridView1.ColumnCount = 3

        'Hide the last blank line
        dataGridView1.AllowUserToAddRows = False

        'Add Columns
        dataGridView1.Columns(0).Name = "CustomerId"
        dataGridView1.Columns(0).HeaderText = "CustomerId Id"
        dataGridView1.Columns(0).DataPropertyName = "CustomerId"
        dataGridView1.Columns(0).Width = 100

        dataGridView1.Columns(1).HeaderText = "Name"
        dataGridView1.Columns(1).Name = "Name"
        dataGridView1.Columns(1).DataPropertyName = "Name"
        dataGridView1.Columns(1).Width = 100

        dataGridView1.Columns(2).Name = "Country"
        dataGridView1.Columns(2).HeaderText = "Country"
        dataGridView1.Columns(2).DataPropertyName = "Country"
        dataGridView1.Columns(2).Width = 100

        Dim checkBoxColumn As New DataGridViewCheckBoxColumn()
        checkBoxColumn.HeaderText = ""
        checkBoxColumn.Width = 30
        checkBoxColumn.Name = "checkBoxColumn"
        dataGridView1.Columns.Insert(0, checkBoxColumn)

        Me.BindGrid()
    End Sub

    Private Sub BindGrid()
        dataGridView1.DataSource = Nothing
        Using con As New SqlConnection(ConnectionString)
            Using cmd As New SqlCommand("SELECT CustomerId, Name, Country FROM Customers", con)
                cmd.CommandType = CommandType.Text
                Using sda As New SqlDataAdapter(cmd)
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        dataGridView1.DataSource = dt
                    End Using
                End Using
            End Using
        End Using
    End Sub

    Private Sub btnDelete_Click(sender As Object, e As EventArgs) Handles btnDelete.Click
        Dim selectedRows As List(Of DataGridViewRow) = (From row In dataGridView1.Rows.Cast(Of DataGridViewRow)() _
                                                        Where Convert.ToBoolean(row.Cells("checkBoxColumn").Value) = True).ToList()
        If MessageBox.Show(String.Format("Do you want to delete {0} rows?", selectedRows.Count), "Confirmation", MessageBoxButtons.YesNo) = DialogResult.Yes Then
            For Each row As DataGridViewRow In selectedRows
                Using con As New SqlConnection(ConnectionString)
                    Using cmd As New SqlCommand("DELETE FROM Customers WHERE CustomerId = @CustomerId", con)
                        cmd.CommandType = CommandType.Text
                        cmd.Parameters.AddWithValue("@CustomerId", row.Cells("CustomerId").Value)
                        con.Open()
                        cmd.ExecuteNonQuery()
                        con.Close()
                    End Using
                End Using
            Next

            Me.BindGrid()
        End If
    End Sub
End Class
